#pragma once
#include "Snake.h"

struct AnimIterator {
	int at = 0;
	double rot = 0;
	Snake* snake;
	bool done = false;

	AnimIterator() {
		
	};

	AnimIterator(Snake* snake):snake(snake) {
		at = snake->bodyParts.size() - 1;
	}

	void step() {
		if (at >= snake->bodyParts.size())return;
		rot += 0.8;
		for (int i = 0; i < snake->bodyParts.size(); i++) {
			snake->bodyParts[i].rot = 0;
		}
		snake->bodyParts[at].rot = rot;
		if (rot > 6.28) {
			rot = 0;
			snake->bodyParts[at].rot = 0;
			at--;
		}
		if (at < 0) {
			at = snake->bodyParts.size();
			done = true;
		}
	}
};