#pragma once
template<typename T>
class Vector2
{
public:
	T x;
	T y;

	Vector2() {};

	Vector2(T x, T y) {
		this->x = x;
		this->y = y;
	};

	Vector2 add(Vector2& v) {
		x += v.x;
		y += v.y;
		return *this;
	}

	Vector2 sub(Vector2& v) {
		x -= v.x;
		y -= v.y;
		return *this;
	}

	Vector2 scale(float scalar) {
		x *= scalar;
		y *= scalar;
		return *this;
	}

	Vector2 lerp(Vector2& v, float weight) {
		return c().add(v.c().sub((*this)).scale(weight));
	}

	T get(int i) {

	}

	void set(int i, T val) {

	}

	bool equals(Vector2 v) {
		return x == v.x && y == v.y;
	}

	Vector2 c() {
		Vector2 c;
		c.x = x;
		c.y = y;
		return c;
	}

	Vector2<int> toInt() {
		Vec2i v;
		v.x = (int)x;
		v.y = (int)y;
		return v;
	}
};

typedef Vector2<float>	Vec2f;
typedef Vector2<int>	Vec2i;